
PImage HG; //Hintergrundbild
PImage bird; //Vogelbild
int HGx; //Hintergrund x
int HGy; //Hintergrund y
int Bx; //Bird x
int By; //Bird  y
int u=1; //Bewegung nach unten
int Bu; //Schnelligkeit nach oben Bewegung
int saulenSpeed = 2;
int saulenAbstand = 70; // alle x Bilder kommt eine Säule (60 Bilder = 1 Sekunde)
int phase=1; //Phasen

int state; //score int's
int speicher;
int score = 0; //Score bei 0 ausgehen

ArrayList<Saule> saulen = new ArrayList<Saule>(); //Arrays Liste von den Säulen



void setup(){ //Einmalige Durchführung
  size(900, 504); //Grösse Spiel
  HG=loadImage("HG.png"); //Bild hochladen
  bird=loadImage("bird.png"); //Vogel hochladen
  textSize(20); //
  fill(255);
  textAlign(CENTER);
  state=0; //Ursprungszustand
  createMenu();
  
}
  

//Hintergrund bewegen lassen
void draw() //mehrmalige Durchführung
{
  if (state == 0) {   // Menü
    createMenu();
    score = 0;
    loadGameData();
  } else if (state == 1) { // Game

    image(HG, HGx, HGy);
    image(HG, HGx+900, HGy);
    HGx=HGx-4; // Geschwindigkeit Hintergrund
    if (HGx<-900) //Neustart
      HGx=0;


    // Hier wird alle ''(saulenAbstand) Frames'' eine neue Säule hergestellt
    if (frameCount % saulenAbstand == 0) {
      int offset = int(random(0, 100));

      // new Saule(x, y, breite, höhe) =>Koordinaten der Säule
      Saule sauleOben = new Saule(width+100, 0, 35, 200-offset, true);
      Saule sauleUnten = new Saule(width+100, height-150-offset, 35, 300, false);
      saulen.add(sauleUnten); // Säule in die Liste eintragen
      saulen.add(sauleOben);
    }
    
   
     //Bedingungen
    for (int i = 0; i < saulen.size(); i++) {
      Saule aS = saulen.get(i);
      aS.x-=saulenSpeed; // Röhren laufen von rechts nach links
      aS.display(); // Röhre anzeigen lassen auf Spielbildschirm
      
      if (aS.type) { //Anzeigen, wenn eine Röhre oben ist
       if (Bx+bird.width > aS.x && Bx+bird.width < aS.x+aS.w && By< aS.y+aS.h) aS.touch();
      } 
      else { // Wenn eine Röhre unten ist
        if (Bx+bird.width > aS.x && Bx+bird.width < aS.x+aS.w && By+bird.height >= aS.y) aS.touch();
      }

      if (By>height) aS.touch(); //Wenn der Vogel oben aus dem Fenster geht
      if (By<0) aS.touch(); //Wenn der Vogel unten aus dem Fenster geht

      if (Bx+bird.width > aS.x && Bx < aS.x+aS.w) { //Scorezähler

        if (speicher/30f + 1 < frameCount/30f) {
          score++;
          speicher=frameCount;
        }
      }
    }
    
    //Score-Anzeige
    textAlign(LEFT); //Score schreiben
    fill(#FFFFFF);
    text("Score: " + score, 50, 30);
    textAlign(CENTER);


    //Vogel einbauen
    {
      image(bird, Bx, By);
      By=By+Bu;
      Bu=Bu+1;
    }
  } 
  
  
  else {
    // Game Over Anzeige
    if (speicher+2==frameCount) {
      background(0);
      fill(#FFFFFF);
      textSize(30);
      text("Game Over", width/2, height/2);
      textSize(20);
      text("Score: " + score, width/2, height/2+30);


      if (highscore < score) { // Überprüfung ob es einen neuen Highscore gibt
        highscore = score;
        saveGameData();

        textAlign(CENTER); //Anzeige neuer Highscore
        fill(255, 0, 0);
        text("Neuer Highscore!", width/2, height/2+60);
        textAlign(LEFT);
      } else { //Anzeige nur Score, aber nicht der ''neue Highscore''
        textAlign(CENTER);
        fill(255, 0, 0);
        text("Highscore: " + highscore, width/2, height/2+60);
      }
    }

    if (speicher/30f + 10 < frameCount/30f) state = 0; // Automatischer Wechsel zurück ins Menü nach ca. 10 Sekunden
    saulen.clear();
  }
}


void keyPressed() { //Klick-Funktion auf Leertaste
  println(keyCode);
  if (keyCode == 32) Bu=-10;

  if (key == 'a' && state == 0) { //Wenn man "a" drückt => Spielstart
    Bx+=30;
    By=height/2-100;
    state=1;
  }
}
//Klick-Funktion auf Mousepad
void mousePressed() { //Mausklick
  Bu=-10; //15 nach oben bei der y Koordinate
}


// Objekt
class Saule { //Deklaration/Einordnung einer Klasse
  int x, y, w, h; //Variablen der  Klasse
  boolean type; // true = oben

  Saule(int x, int y, int w, int h, boolean type) { // "Statements"
    this.x = x;
    this.y = y;
    this.w = w;
    this.h = h;
    this.type =type;

    saulen.add(this);
  }

  void display() { //Erstellung Display
    fill(0, 255, 0);
    rectMode(CORNER); //Standartmodus Rechteck
    rect(this.x, this.y, this.w, this.h); //Erster und zweiter Parameter: obere linke Ecke der Form, dritte und vierte Parameter: Breite und Höhe 
  }

  void touch() {
    speicher = frameCount;
    state++;
  }
}


// Startbildschirm wird gezeichnet
void createMenu() {
  background(0);

  fill(255);
  text("Drücke 'a' zum starten", width/2, height/2);// "a" drücken um erneut zu starten
  text("Spiele mit der Leertaste oder der Maus und gehe zwischen den Säulen durch", 460, 150);
}
//Ende des Spielcodes
